GreatWksGraph Class Reference documentation

GreatWksGraph Class Reference

the main class to read the graphic part of a HanMac Word-J file More...

`#include <GreatWksGraph.hxx>`

## Public Member Functions
| GreatWksGraph (GreatWksDocument &document)
| constructor
virtual | ~GreatWksGraph ()
| destructor
int | version () const
| returns the file version
int | numPages () const
| returns the number of pages

## Protected Member Functions
bool | sendPageGraphics ()
| try to send the page graphic
void | flushExtra ()
| sends the data which have not yet been sent to the listener
bool | readPatterns (MWAWEntry const &entry)
| read a pattern list block ( PAT# resource block )
bool | readPalettes (MWAWEntry const &entry)
| read a list of color and maybe patterns ( PlTT resource block: v2 )
bool | sendPageFrames (GreatWksGraphInternal::Zone const &zone)
| try to send all data corresponding to a zone
bool | sendFrame (std::shared_ptr< GreatWksGraphInternal::Frame > frame, GreatWksGraphInternal::Zone const &zone)
| try to send a frame
bool | sendGroup (GreatWksGraphInternal::FrameGroup const &group, GreatWksGraphInternal::Zone const &zone, MWAWPosition const &pos)
| try to send a group
void | sendGroupChild (GreatWksGraphInternal::FrameGroup const &group, GreatWksGraphInternal::Zone const &zone, MWAWPosition const &pos)
| try to send a group elements by elemenys
bool | canCreateGraphic (GreatWksGraphInternal::FrameGroup const &group, GreatWksGraphInternal::Zone const &zone)
| check if we can send a group as graphic
void | sendGroup (GreatWksGraphInternal::FrameGroup const &group, GreatWksGraphInternal::Zone const &zone, MWAWGraphicListenerPtr &listener)
| send the group as a graphic zone
bool | sendTextbox (GreatWksGraphInternal::FrameText const &text, GreatWksGraphInternal::Zone const &zone, MWAWPosition const &pos)
| try to send a textbox
bool | sendTextboxAsGraphic (MWAWBox2f const &box, GreatWksGraphInternal::FrameText const &text, MWAWGraphicStyle const &style, MWAWListenerPtr listener)
| try to send a textbox via a graphiclistener
bool | sendTextbox (MWAWEntry const &entry, MWAWListenerPtr listener)
| try to send the textbox text (via the mainParser)
bool | sendPicture (MWAWEntry const &entry, MWAWPosition const &pos)
| try to send a picture
bool | sendShape (GreatWksGraphInternal::FrameShape const &graph, GreatWksGraphInternal::Zone const &zone, MWAWPosition const &pos)
| try to send a basic picture
bool | readGraphicZone ()
| try to read the graphic zone ( draw file or end of v2 text file)
bool | isGraphicZone ()
| return true if this corresponds to a graphic zone
bool | findGraphicZone ()
| try to find the beginning of the next graphic zone
bool | isPageFrames ()
| check if a zone is or not a page frame zone
bool | readPageFrames ()
| try to read a list of page frame ( picture, texture or basic )
std::shared_ptr< GreatWksGraphInternal::Frame > | readFrameHeader ()
| try to read a basic frame header
bool | readFrameExtraData (GreatWksGraphInternal::Frame &frame, int id, long endPos=-1)
| try to read a frame extra data zone
bool | readStyle (MWAWGraphicStyle &style)
| try to read a zone style
bool | readLineFormat (std::string &extra)
| try to read a line format style? in v1
bool | readFrameExtraDataRec (GreatWksGraphInternal::Zone &zone, int id, std::set< int > &seens, long endPos=-1)
| try to read a frame extra data zone recursively ( draw method)
bool | checkGraph (GreatWksGraphInternal::Zone &zone, int id, std::set< int > &seens)
| check if the graph of zones is ok (ie. does not form loop)

## Protected Attributes
GreatWksDocument & | m_document
| the document
MWAWParserStatePtr | m_parserState
| the parser state
std::shared_ptr< GreatWksGraphInternal::State > | m_state
| the state
MWAWParser * | m_mainParser
| the main parser;

## Private Member Functions
| GreatWksGraph (GreatWksGraph const &orig)=delete
GreatWksGraph & | operator= (GreatWksGraph const &orig)=delete

## Friends
class | GreatWksDocument
class | GreatWksParser
class | GreatWksDBParser
class | GreatWksDRParser
class | GreatWksSSParser
class | GreatWksGraphInternal::SubDocument

## Detailed Description

the main class to read the graphic part of a HanMac Word-J file

## Constructor & Destructor Documentation

## ◆ GreatWksGraph() [1/2]

GreatWksGraph::GreatWksGraph | ( | GreatWksDocument & | document | ) |
| explicit

constructor

Referenced by GreatWksGraph(), and operator=().

## ◆ ~GreatWksGraph()

GreatWksGraph::~GreatWksGraph | ( |  | ) |
| virtual

destructor

## ◆ GreatWksGraph() [2/2]

GreatWksGraph::GreatWksGraph | ( | GreatWksGraph const & | orig | ) |
| privatedelete

## Member Function Documentation

## ◆ canCreateGraphic()

bool GreatWksGraph::canCreateGraphic | ( | GreatWksGraphInternal::FrameGroup const & | group,
|  | GreatWksGraphInternal::Zone const & | zone )
| protected

check if we can send a group as graphic

Referenced by canCreateGraphic(), and sendGroupChild().

## ◆ checkGraph()

bool GreatWksGraph::checkGraph | ( | GreatWksGraphInternal::Zone & | zone,
|  | int | id,
|  | std::set< int > & | seens )
| protected

check if the graph of zones is ok (ie. does not form loop)

Referenced by checkGraph(), and readPageFrames().

## ◆ findGraphicZone()

bool GreatWksGraph::findGraphicZone | ( |  | ) |
| protected

try to find the beginning of the next graphic zone

Referenced by readGraphicZone().

## ◆ flushExtra()

void GreatWksGraph::flushExtra | ( |  | ) |
| protected

sends the data which have not yet been sent to the listener

## ◆ isGraphicZone()

bool GreatWksGraph::isGraphicZone | ( |  | ) |
| protected

return true if this corresponds to a graphic zone

Referenced by findGraphicZone(), and readGraphicZone().

## ◆ isPageFrames()

bool GreatWksGraph::isPageFrames | ( |  | ) |
| protected

check if a zone is or not a page frame zone

Referenced by isGraphicZone(), and readPageFrames().

## ◆ numPages()

int GreatWksGraph::numPages | ( |  | ) | const

returns the number of pages

## ◆ operator=()

GreatWksGraph & GreatWksGraph::operator= | ( | GreatWksGraph const & | orig | ) |
| privatedelete

## ◆ readFrameExtraData()

bool GreatWksGraph::readFrameExtraData | ( | GreatWksGraphInternal::Frame & | frame,
|  | int | id,
|  | long | endPos = -1 )
| protected

try to read a frame extra data zone

Referenced by readFrameExtraDataRec(), and readPageFrames().

## ◆ readFrameExtraDataRec()

bool GreatWksGraph::readFrameExtraDataRec | ( | GreatWksGraphInternal::Zone & | zone,
|  | int | id,
|  | std::set< int > & | seens,
|  | long | endPos = -1 )
| protected

try to read a frame extra data zone recursively ( draw method)

Referenced by readFrameExtraDataRec(), and readPageFrames().

## ◆ readFrameHeader()

std::shared_ptr< GreatWksGraphInternal::Frame > GreatWksGraph::readFrameHeader | ( |  | ) |
| protected

try to read a basic frame header

Referenced by readPageFrames().

## ◆ readGraphicZone()

bool GreatWksGraph::readGraphicZone | ( |  | ) |
| protected

try to read the graphic zone ( draw file or end of v2 text file)

## ◆ readLineFormat()

bool GreatWksGraph::readLineFormat | ( | std::string & | extra | ) |
| protected

try to read a line format style? in v1

Referenced by readGraphicZone(), readPageFrames(), and readStyle().

## ◆ readPageFrames()

bool GreatWksGraph::readPageFrames | ( |  | ) |
| protected

try to read a list of page frame ( picture, texture or basic )

Referenced by readGraphicZone().

## ◆ readPalettes()

bool GreatWksGraph::readPalettes | ( | MWAWEntry const & | entry | ) |
| protected

read a list of color and maybe patterns ( PlTT resource block: v2 )

## ◆ readPatterns()

bool GreatWksGraph::readPatterns | ( | MWAWEntry const & | entry | ) |
| protected

read a pattern list block ( PAT# resource block )

## ◆ readStyle()

bool GreatWksGraph::readStyle | ( | MWAWGraphicStyle & | style | ) |
| protected

try to read a zone style

Referenced by readGraphicZone(), and readPageFrames().

## ◆ sendFrame()

bool GreatWksGraph::sendFrame | ( | std::shared_ptr< GreatWksGraphInternal::Frame > | frame,
|  | GreatWksGraphInternal::Zone const & | zone )
| protected

try to send a frame

Referenced by sendGroupChild(), and sendPageFrames().

## ◆ sendGroup() [1/2]

void GreatWksGraph::sendGroup | ( | GreatWksGraphInternal::FrameGroup const & | group,
|  | GreatWksGraphInternal::Zone const & | zone,
|  | MWAWGraphicListenerPtr & | listener )
| protected

send the group as a graphic zone

## ◆ sendGroup() [2/2]

bool GreatWksGraph::sendGroup | ( | GreatWksGraphInternal::FrameGroup const & | group,
|  | GreatWksGraphInternal::Zone const & | zone,
|  | MWAWPosition const & | pos )
| protected

try to send a group

Referenced by sendFrame(), sendGroup(), and sendGroupChild().

## ◆ sendGroupChild()

void GreatWksGraph::sendGroupChild | ( | GreatWksGraphInternal::FrameGroup const & | group,
|  | GreatWksGraphInternal::Zone const & | zone,
|  | MWAWPosition const & | pos )
| protected

try to send a group elements by elemenys

Referenced by sendGroup().

## ◆ sendPageFrames()

bool GreatWksGraph::sendPageFrames | ( | GreatWksGraphInternal::Zone const & | zone | ) |
| protected

try to send all data corresponding to a zone

Referenced by sendPageGraphics().

## ◆ sendPageGraphics()

bool GreatWksGraph::sendPageGraphics | ( |  | ) |
| protected

try to send the page graphic

Referenced by flushExtra().

## ◆ sendPicture()

bool GreatWksGraph::sendPicture | ( | MWAWEntry const & | entry,
|  | MWAWPosition const & | pos )
| protected

try to send a picture

Referenced by sendFrame().

## ◆ sendShape()

bool GreatWksGraph::sendShape | ( | GreatWksGraphInternal::FrameShape const & | graph,
|  | GreatWksGraphInternal::Zone const & | zone,
|  | MWAWPosition const & | pos )
| protected

try to send a basic picture

Referenced by sendFrame().

## ◆ sendTextbox() [1/2]

bool GreatWksGraph::sendTextbox | ( | GreatWksGraphInternal::FrameText const & | text,
|  | GreatWksGraphInternal::Zone const & | zone,
|  | MWAWPosition const & | pos )
| protected

try to send a textbox

Referenced by sendFrame().

## ◆ sendTextbox() [2/2]

bool GreatWksGraph::sendTextbox | ( | MWAWEntry const & | entry,
|  | MWAWListenerPtr | listener )
| protected

try to send the textbox text (via the mainParser)

## ◆ sendTextboxAsGraphic()

bool GreatWksGraph::sendTextboxAsGraphic | ( | MWAWBox2f const & | box,
|  | GreatWksGraphInternal::FrameText const & | text,
|  | MWAWGraphicStyle const & | style,
|  | MWAWListenerPtr | listener )
| protected

try to send a textbox via a graphiclistener

Referenced by sendGroup(), sendGroupChild(), and sendTextbox().

## ◆ version()

int GreatWksGraph::version | ( |  | ) | const

returns the file version

Referenced by findGraphicZone(), isGraphicZone(), isPageFrames(), readFrameHeader(), readGraphicZone(), readPageFrames(), and readStyle().

## Friends And Related Symbol Documentation

## ◆ GreatWksDBParser

friend class GreatWksDBParser
| friend

Referenced by GreatWksDBParser.

## ◆ GreatWksDocument

friend class GreatWksDocument
| friend

Referenced by GreatWksDocument, GreatWksGraph(), and GreatWksGraphInternal::SubDocument.

## ◆ GreatWksDRParser

friend class GreatWksDRParser
| friend

Referenced by GreatWksDRParser.

## ◆ GreatWksGraphInternal::SubDocument

friend class GreatWksGraphInternal::SubDocument
| friend

## ◆ GreatWksParser

friend class GreatWksParser
| friend

Referenced by GreatWksParser.

## ◆ GreatWksSSParser

friend class GreatWksSSParser
| friend

Referenced by GreatWksSSParser.

## Member Data Documentation

## ◆ m_document

GreatWksDocument& GreatWksGraph::m_document
| protected

the document

Referenced by canCreateGraphic(), GreatWksGraph(), sendGroupChild(), sendTextbox(), and sendTextbox().

## ◆ m_mainParser

MWAWParser* GreatWksGraph::m_mainParser
| protected

the main parser;

Referenced by GreatWksGraph(), and sendFrame().

## ◆ m_parserState

MWAWParserStatePtr GreatWksGraph::m_parserState
| protected

the parser state

Referenced by findGraphicZone(), GreatWksGraph(), isGraphicZone(), isPageFrames(), readFrameExtraData(), readFrameExtraDataRec(), readFrameHeader(), readGraphicZone(), readLineFormat(), readPageFrames(), readPalettes(), readPatterns(), readStyle(), sendFrame(), sendGroupChild(), sendPageFrames(), sendPageGraphics(), sendPicture(), sendShape(), sendTextbox(), sendTextboxAsGraphic(), and version().

## ◆ m_state

std::shared_ptr<GreatWksGraphInternal::State> GreatWksGraph::m_state
| protected

the state

Referenced by GreatWksGraph(), numPages(), readPageFrames(), and sendPageGraphics().

The documentation for this class was generated from the following files:

- GreatWksGraph.hxx
- GreatWksGraph.cxx